/***************************************************************

  BayCom(R)   Packet-Radio fuer IBM PC

  OpenBayCom-Mailbox

  -------------------------------------------
  Definitionen und Deklarationen fuer Mailbox
  -------------------------------------------


  Copyright (c)       Florian Radlherr
                      Taubenbergstr. 32
                      D-83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/


//19980115 OE3DZW removed obsolete defines, changed fbb-fwd-path
//                added ad_timezone()
//19980124 OE3DZW added define for REJECTLOGNAME
//19980202 OE3DZW added option for new callcheck (from hrx), id for cb-mode
//19980208 OE3DZW defined BETREFFLEN
//19980211 OE3DZW added bytes/connects to fwdpara_t
//19980215 OE3DZW added define for syslog_r.bcm
//19980218 OE3DZW added msgty(pe) to mailflags
//19980301 OE3DZW added ax25_set_pid (mbflex.cpp)
//19980226 hrx    added taskwin to functions (mbinterf.cpp)
//19980301 OE3DZW added killforwarded, add_hold
//19980311 DG9MHZ changes for Linux-Kernel AX25
//19980324 DH3MB  support for md2/5
//19980408 hrx    cbmodeid changed (from /cb to cb)
//                autotrcwin added to mailpara_t
//                mbcheckcount added to functions, section mbcheck.cpp
//                trcwin added to functions, section mbinterf.cpp
//19980411 hrx    changed type of mbcheckcount() to long
//                added autofwd as part of hrx_opt
//                added mbafwd.cpp to function section, currently
//                autofwd() and fwdlist() are used
//19980613 hrx    added _paclen conditional to hrx_opt
//                added _asklogin conditional tp hrx_opt
//                added _cfwd conditional tp hrx_opt
//                added CHECKNUMNAME  "checknum.bcm" and
//                CHECKNUMTMP "checknum.$$$". used for autofwd.
//                added paclen int to user_t, mailpara_t. added
//                structures hadr_t, hadr_old_t, used for autofwd.
//                added uclose(), hadr_tryopen(), loadhadr() to functions,
//                section mbhadr.cpp. added createboardfwd to mailpara_t
//                added autofwdtime to mailpara_t
//19980619 OE3DZW moved defines for options to baycom.h
//19980913 OE3DZW added savebroken
//19981015 OE3DZW added parameters for wxstation
//19990111 OE3DZW added dirformat to user-database
//19990714 DH3MB  Changed declarations for mbfwd.cpp and mbfwdrli.cpp
//19991028 Jan    added defines for AX25K_ONLY
//20000624 DK2UI  changed size of struct reject_t for regular expressions
//20020724 DH8YMB name changed from "BCM" to "OpenBCM"
//20021130 DH8YMB HRX_OPT Optionen fest eingebaut
//20030102 hpk    added minpaclen, maxpaclen, defrea to mailpara_t
//20030102 hpk    added pwonly for the CB-BCMNET login-concept to mailpara_t
//20030102 hpk    added logintype for the CB-BCMNET login-concept to t_var_t
//20030109 DH8YMB defpaclen hinzu
//20030706 DB1RAS added CB-BCMNET modeid and support message
//20030706 DB1RAS added dospreexec and dospostexec in mailpara_t
//20030809 DB1RAS added CB-BCMNET gateway functions
//20030821 DH8YMB added mbfwdfil.cpp
//20031010 DH8YMB Userdatenbank neues Format in users4.bcm
//20031226 DH6BB  FTP-Server fuer den Filesurf

/*---------------------------------------------------------------------------*/

#undef  VNUMMER
#define VNUMMER         "1.05_bn3"
#define STD_BOXHEADER   "OpenBCM"
#define LOGINSIGN       STD_BOXHEADER" V"VNUMMER" ("OPSYSTEM")"
#define AUTHOR_ID       "(c) GNU GPL 1992-"YEAR" F. Radlherr, DL8MBT et al.\n" \
                        "OpenBCM is maintained by Markus Baumann, DH8YMB\n" \
                        "http://www.baycom.org/baybox/\n"
#if ! defined _BCMNET || ! defined _BCMNET_FWD || ! defined _BCMNET_LOGIN
  #define CBMODEID      "(CB)"
  #define CBSUPPORT     "CB-Version, Support by DJJ812/DO1MJJ - http://www.dbo812.de\n"
#else
  #define CBMODEID      "*CB-BCMNET*"
  #define CBSUPPORT     "CB-BCMNET Version, Support by AS1GBF,AT5HPK,HF1BKM" \
                        " - bcmnet@afulinux.de\n"
#endif

//*************************************************************************
//  path and file names
//*************************************************************************
#define MSGPATH         "msg"
#define SYSTEMPATH      "system"
#define LOGPATH         "log"
#define TRACEPATH       "trace"
#define TEMPPATH        "temp"
#define FWDPATH         "fwd"
#define FBBPATH         "fwd/fbb"
#define FWDEXPATH       "fwd/export"
#define FWDIMPATH       "fwd/import"

#define CRONTABNAME     "crontab.bcm"
#define VIDNAME         "dosvid.bcm"
#define FWDLISTNAME     "fwd.bcm"
#define FWDLISTNAMEBAK  "fwd.bak"
#ifdef _AUTOFWD
#define AFWDLISTNAME    "afwd.bcm"
#define AFWDTMP         "temp/afwd1.tmp"
#endif
#define BEACONNAME      "beacon.bcm"
#define CONVFILENAME    "convert.bcm"
#define CONVTMPNAME     "convname.$$$"
#ifdef __MSDOS__
  #define USERNAMEOLD   "users.bcm"
#else
  #define USERNAMEOLD   "users3.bcm"
#endif
#define USERNAME        "users4.bcm"
#define USERNAMEBAK     "users4.bak"
#define USERNAMETMP     "users4.$$$"
#define UTMP            "users.$$$"
#ifdef __MSDOS__
#define HADROLDNAME     "hadr2.bcm"
#define BIDNAME         "bids2.bcm"
#define BIDNAME_L       "bids3.bcm"
#else
#define HADROLDNAME     "hadr3.bcm"
#define BIDNAME         "bids3.bcm"
#endif
#define HADRNAME         "hadr4.bcm"
#define HADRHASHNAME     "hadrhash.bcm"
#define USERHASHNAME_OLD "userhash.bcm"
#define UHTMP            "userhash.$$$"
#define USERHASHNAME     "userh2.bcm"
#define USERHASHNAMEBAK  "userh2.bak"
#define BIDHASHNAME      "bidh2.bcm"
#define BTMP            "bids2.$$$"
#define BHTMP           "bidh2.$$$"
#define BBAK            "bids2.bak"
#define BHBAK           "bidh2.bak"
#define DIRLISTNAME     "list.bcm"
#define DIRTMPNAME      "list.$$$"
#define MBINITNAME      "init.bcm"
#define MBINITOLDNAME   "bcm.ini"
#define INITTMPNAME     "init.$$$"
#define INITBAKNAME     "init.bak"
#define LOGNAME         "log.bcm"
#define CHECKNAME       "check.bcm"
#define CHECKTMPNAME    "check.$$$"
#define CHECKNUMNAME    "checknum.bcm"
#define CHECKNUMTMP     "checknum.$$$"
#define PASSWDNAME      "passwd.bcm"
#define PRIVNAME        "pwlist.bcm"
#define TREENAME        "bulletin.bcm"
#define TREETMPNAME     "bulletin.$$$"
#define TREEBAKNAME     "bulletin.bak"
#define SYSLOGNAME      "syslog.bcm"
#define SYSLOGRNAME     "syslog_r.bcm"
#define CMDLOGNAME      "cmdlog.bcm"
#define PWLOGNAME       "pwlog.bcm"
#define ERASELOGNAME    "eraselog.bcm"
#define UNKNOWNNAME     "unknown.bcm"
#define SFHOLDNAME      "sfhold.bcm"
#define SWAPLOGNAME     "swap.bcm"
#define MFILTERLOGNAME  "m_filter.bcm"
#define RUNDATNAME      "rundat.bcm"
#define BIDNAME_OLD     "bids.bcm"
#define BIDHASHNAME_OLD "bidhash.bcm"
#define RUNNAME         "runutil.bcm"
#define MAILLISTNAME    "mailserv.bcm"
#define MAILLISTTMPNAME "mailserv.$$$"
#ifdef DF3VI_POCSAG
  #define POCSAGLISTNAME "pocsag.bcm"
  #define POCSAGLISTTMP  "pocsag.$$$"
#endif
#define OLDUMAILLOGNAME "oldumail.bcm"
#define REJECTLOGNAME   "rejlog.bcm"
#define REJECTNAME      "reject.bcm"
#ifdef DF3VI_REJ_EDIT
  #define REJECTTMPNAME "reject.bak"
#endif
#define POPDBNAME       "popstate.bcm"
#define POPDBTMPNAME    "popstate.$$$"
#define BEACONHEADNAME  "beachead.bcm" //header for beacon
#define ISSUENAME       "issue.bcm"
#define BOARDINFO       "boardinf.bcm"
#define CONVATNAME      "convat.bcm"
#define RHOSTSNAME      "rhosts.bcm"
#define L2INITNAME      "init.l2"
#define L2PATHNAME      "netpath.bcm"
#define HTMP            "hadrs.$$$"
#define HHTMP           "hadrhash.$$$"
#ifdef _TTY // JJ
 #define INITTTYNAME    "inittty.bcm"
 #define INITTTYTMPNAME "inittty.$$$"
 #define INITTTYBAKNAME "inittty.bak"
#endif
#ifdef MACRO
 #define EVENTNAME      "macro.bcm"
#endif
#ifdef _TTY
 #define conlogintext   "ctextcon"
 #define ttylogintext   "ctexttty"
#endif

/*---------------------------------------------------------------------------*/

// htlm-defines and tcpip ports
#define HTMLSTARTTAG    "<HTML>"
#ifdef __FLAT__
  #define MIME_JPG        "image/jpeg"
  #define MIME_GIF        "image/gif"
  #define MIME_TXT        "text/html"
  #define MIME_BIN        "application/x-binary"
  #define MIME_WAV        "audio/wav"
  #define DEFFTPPORT      8021
  #define DEFSMTPPORT     8025
  #define DEFPOP3PORT     8110
  #define DEFNNTPPORT     8119
  #define DEFHTTPPORT     8080
  #define DEFTELNPORT     4719
  #define DEFSERVPORT     8123
  #define DEFRADIOPORT    8124
#endif

/*---------------------------------------------------------------------------*/

// flags of "7plus" by dg1bbq
#define START7PFLAG     " go_7+. "
#define STOP7PFLAG      " stop_7+. "
#define STARTINFOFLAG   " go_info. "
#define STOPINFOFLAG    " stop_info."
#define STARTTEXTFLAG   " go_text. "
#define STOPTEXTFLAG    " stop_text."

/*---------------------------------------------------------------------------*/

#define FWDOK   0
#define FWDNO   1
#define FWDREJ  2
#define FWDERR  3

#define BINMODE_AUTOBIN 0
#define BINMODE_YAPP    1
#define BINMODE_DIDADIT 2

#define SEPLINE "-------------------------------------------------------------------------------"

/*---------------------------------------------------------------------------*/

#ifdef __FLAT__
#define US_CACHESZ 128   // user database cache
#else
#define US_CACHESZ 1     // for DOS reduced because of DGROUP > 64k
#endif

/*---------------------------------------------------------------------------*/

//*************************************************************************
//  Defines of special strings
//*************************************************************************
#define CALLEN          6
#define DIRLEN          8      // boardname
#define CALLSSID        9      // call with SSID
#define BIDLEN          12
#define NAMELEN         14
#define MYBBSLEN        39     // length of complete MyBBS incl. H-Route
#define OLDMYBBSLEN     24     // for compatibility with the old mybbs field
#define PROMPTLEN       20
#define FIRSTCMDLEN     20
#define QTHLEN          30
#define ZIPLEN          8
#define HADRESSLEN      39     // complete H-Route
#define MAXPARSE        40
#define BINCMDLEN       80     // fix size of BIN-header within mail files
#define BETREFFLEN      80     // max. length of title
#define LINELEN         80     // standard line length
#define FSPATHLEN       100
#define BLEN            128    // line len of most binary files
#define LBLEN           128L
#define CMDBUFLEN       130
#define DESTBOXLEN      (MAXFWD*7)
#define BUFLEN          300
#define CBUFLEN         8192   // copy buffer size (1L << 13)
#define ADJNUM          20
#define HEADERLEN       60
#define BSTATUSLEN      20
#define BHWADDRESSLEN   49
#define BPROTOLEN       10
#define BVERSION        10     // Version 1.0
#define BSTATUS         "0"    // inactive
#define FBBMSGNUMOFFSET 100000L // Unterscheidung von FBB-Check-Nr.+DIR/LIST-Nr.
#define LOGLEN          20
#define MAXLOGSUM       1000

#ifdef RUNUTILS
#define RUN_CMDLEN      11
#define RUN_EXELEN      19
#define RUN_COMLEN      65
#define RUN_PARAMLEN    130    // max. length of parameters for run-util
#endif

/*---------------------------------------------------------------------------*/

#define BOARDLEER       (-1)
#define MAXBEREICH      (ULONG_MAX)
#define HASH16          (65536L)    // (1L << 16)
#define HASH32          (65536L*2)  // (1L << 17)
#define MAXMAILLEN      9999999L    // Max. maillength ca. 10 MBytes
#define MAXMAILDIG      7
#define HOUR            3600L       // 60 * 60
#define DAY             86400L      // 60 * 60 * 24
#define MAXAGE          2529000L    // 60 * 60 * 24 * 30 max. age of incomimg mybbs
#ifdef _BCMNET
  #define USERPROTECT   183L * DAY  // Zeitspanne fr den Userschutz
  #define BCMNETID      ".BCMNET"
#endif

// Min. available diskspace in kbytes
#define USERDISKFULL    500L
#define INFODISKFULL    1000L
#define HOMEDISKFULL    1000L

//*************************************************************************
//  Characters used in YAPP-file-transfer and FBB-forwarding (DH3MB)
//*************************************************************************
#define NUL   0x00 // End of string / Separator
#define SOH   0x01 // Start of header
#define STX   0x02 // Start of transmission
#define ETX   0x03 // End of transmission
#define EOT   0x04 // End of Transfer
#define ENQ   0x05 //
#define ACK   0x06 // Acknowledgement
#define DLE   0x10 //
#define NAK   0x15 // Negative Acknowledgenment
#define CTRLX 0x18 // Cancel
#define CTRLZ 0x1a
#define ESC   0x1b

//*************************************************************************
// Use THIS!
//*************************************************************************
#define safe_strncpy(a,b,n)             {strncpy(a,b,n-1);a[n-1]=0;}
#define safe_strcpy(a,b)                safe_strncpy(a,b,sizeof(a))

/*---------------------------------------------------------------------------*/

typedef unsigned long bitfeld;

#pragma pack(1)  // Alignment auf 1 Byte setzen
typedef struct user_t
//*************************************************************************
//
//  Struktur fuer die users4.bcm Userdatenbank
//
//*************************************************************************
{ char     call[CALLEN+1];          //  7 Rufzeichen des Users
  char     name[NAMELEN+1];         // 15 A NAME
  char     qth[QTHLEN+1];           // 31 QTH (DH8YMB)
  char     qthok;                   //  1 QTH selbst eingegeben
  char     zip[ZIPLEN+1];           //  9 ZIP-Code (Postleitzahl) (DH8YMB)
  char     zipok;                   //  1 Zip-Code selbst eingegeben
  char     mybbs[MYBBSLEN+1];       // 40 A FORWARD
  char     mybbsok;                 //  1 MYBBS selbst eingegeben
  time_t   mybbstime;               //  4 Datum des letzten MYBBS (UNIX)
  char     uplink[CALLSSID+1];      // 10 uplink-Digi
  char     newcall[CALLEN+1];       //  7 New callsign (license update)
  char     prompt[PROMPTLEN+1];     // 21 A PROMPT
  char     sprache[4];              //  4 A SPEECH
  char     password[40];            // 40 A PW (pw off = 0x01 0x00 ...)
  char     notvisible[LINELEN];     // 80 A REJECT
  char     firstcmd[FIRSTCMDLEN+1]; // 21 A COMMAND
  short unsigned helplevel;         //  2 A HELPLEVEL
  long unsigned logins;             //  4 Anzahl an Logins
  short unsigned lf;                //  2 A LF
  short unsigned zeilen;            //  2 A LINES
  char     nopurge;                 //  1 Board wird nicht geputzt
  char     nameok;                  //  1 Name selbst eingegeben
  time_t   lastboxlogin;            //  4 letzter Login (UNIX)
  time_t   lastdirnews;             //  4 letztes DIR NEWS / Check (UNIX)
  time_t   lastquit;                //  4 letztes QUIT
  time_t   lastload;                //  4 interner Merker fr Verwaltung
  long     mailsent;                //  4 gesendete Nachrichten
  long     mailgot;                 //  4 erhaltene Nachrichten
  long     mailread;                //  4 gelesene Nachrichten
  long unsigned  daybytes;          //  4 gelesene Bytes heute
  bitfeld  opt[8];                  // 32 eingestellte Optionen
  char     ufwd[HADRESSLEN+1];      // 40 Connect-Path fuer User-forwarding
  char     loginpwtype;             //  1 Password-type for ax-login (DH3MB)
                                    //    0..BayCom-Password
                                    //    1..MD2
                                    //    2..MD5
                                    //    100..disabled
  char     sfpwtype;                //  1 Password-type for S&F (DH3MB)
                                    //    0..BayCom-Password
                                    //    1..MD2
                                    //    2..MD5
                                    //    100..disabled
  char     ttypw[9];                //  9 A TTYPW (TTY-Password)
  short unsigned fdelay;            //  2 Verzoegerung fr eigene Nachrichten
  short unsigned fhold;             //  2 Verzoegerung fr Nachrichten
  short unsigned status;            //  2 A STATUS (Bit-field)
                                    //    0..default
                                    //    1..no quota-limits
                                    //    2..access denied
                                    //    4..access denied, sysop informed
                                    //    8..my not use transfer command
  char     readlock;                //  1 Privatmails nicht lesbar
  char     rlimit;                  //  1 fremde Privatmails nicht lesbar
  char     pwline;                  //  1 Leerzeile beim Login
  char     echo;                    //  1 Eigene Eingaben zurckschicken
  short unsigned paclen;            //  2 Packetlength
  char     dirformat;               //  1 Dir/Check/List in new format
  char     binmode;                 //  1 AutoBIN/YAPP/DIDADIT bei BIN-Mails
  char     unsecure_smtp;           //  1  0=>needs to pop before smtp
                                    //     1=>smtp without pop allowed
  char     away;                    //  1 AWAY-Funktion aktiv/deaktiv (DH8YMB)
  time_t   awayendtime;             //  4 AWAY Endtime (UNIX)
  char     awaytext[LINELEN];       // 80 AWAY Text
  char     charset;                 //  1 A CHARSET (nicht implementiert)
  char     ttycharset;              //  1 TTY-Charset (nicht implementiert)
  char     fbbcheckmode;            //  1 FFB-Check/Read-Mode
  char     notification[CALLEN+1];  //  7 Mailbenachrichtigung
  char     linuxpw[9];              //  9 A LINUXPW (Linux-System-Passwort)
  char     restplatz[90];           // 90 Restplatz

  short unsigned filepos_old;       //  2 Position im Userfile (altes Format)
  short unsigned nextsamehash_old;  //  2 Link Hashliste (altes Format)
  long unsigned filepos;            //  4 Position im Userfile
  long unsigned nextsamehash;       //  4 Link Hashliste
                                    //  = 640 Bytes
} user_t ;
#pragma pack() // Alignment zurueck auf Default

/*---------------------------------------------------------------------------*/

#ifdef _USERS4CONVERT
#ifdef __MSDOS__
typedef struct userold_t
//*************************************************************************
//
//  Struktur fuer die alten Userdaten users.bcm (DOS)
//
//*************************************************************************
{ char     call[CALLEN+1];          //  7 Rufzeichen des Users
  char     name[NAMELEN+1];         // 15 A NAME
  char     oldmybbs[OLDMYBBSLEN+1]; // 25 for compatibility with old mybbs field
  char     prompt[PROMPTLEN+1];     // 21 A PROMPT
  char     sprache[4];              //  4 A SPEECH
  char     password[40];            // 40 A PW ; pw off = 0x01 0x00 ..
  char     notvisible[LINELEN];     // 80 A REJECT
  char     firstcmd[FIRSTCMDLEN+1]; // 21 A COMMAND
  short unsigned helplevel;         //  2 A HELPLEVEL
  short unsigned zeilen;            //  2 A LINES
  char     nopurge;                 //  1 Board wird nicht geputzt
  char     nameok;                  //  1 Name selbst eingegeben
  time_t   lastboxlogin;            //  4 letzter Login (UNIX)
  time_t   lastdirnews;             //  4 letztes DIR NEWS / Check (UNIX)
  time_t   lastquit;                //  4 letztes QUIT
  long     mailsent;                //  4 gesendete Nachrichten
  long     mailgot;                 //  4 erhaltene Nachrichten
  long     mailread;                //  4 gelesene Nachrichten
  long unsigned logins;             //  4 logins
  char     mybbsok;                 //  1 MYBBS selbst eingegeben (1)
  bitfeld  opt[8];                  // 32 eingestellte Optionen
  short unsigned lf;                //  2 A LF
  char     charset;                 //  1 A CHARSET (nicht impl)
  time_t   mybbstime;               //  4 Datum des letzten MYBBS (UNIX)
  char     ttypw[9];                //  9 A TTYPW (TTY-Password)
  time_t   lastload;                //  4 interner Merker fr Verwaltung
  long unsigned  daybytes;          //  4 gelesene Bytes heute
  short unsigned status;            //  2 A STATUS (Bit-field)
                                    //    0..default
                                    //    1..no quota-limits
                                    //    2..access denied
                                    //    4..access denied, sysop informed
                                    //    8..my not use transfer command
  char     uplink[CALLSSID+1];      // 10 uplink-Digi
  char     readlock;                //  1 Privatmails nicht lesbar (")
  char     pwline;                  //  1 Leerzeile beim Login
  char     echo;                    //  1 Eigene Eingaben zurckschicken
  short unsigned fdelay;            //  2 Verzoegerung fr eigene Nachrichten
  short unsigned fhold;             //  2 Verzoegerung fr Nachrichten
  char     rlimit;                  //  1 fremde Privatmails nicht lesbar
  char     ufwd[40];                // 40 Connect-Path fuer User-forwarding
  char     loginpwtype;             //  1 Password-type for ax-login (DH3MB)
                                    //    0..BayCom-Password
                                    //    1..MD2
                                    //    2..MD5
                                    //    100..disabled
  char     sfpwtype;                //  1 Password-type for S&F (DH3MB)
                                    //    0..BayCom-Password
                                    //    1..MD2
                                    //    2..MD5
                                    //    100..disabled
  char newcall[CALLEN+1];           //  7 New callsign (license update)
  short unsigned paclen;            //  2 Packetlength
  char dirformat;                   //  1 Dir/Check/List in new format
  char binmode;                     //  1 AutoBIN/YAPP/DIDADIT bei BIN-Mails
  char unsecure_smtp;               //  1  0=>needs to pop before smtp
                                    //     1=>smtp without pop allowed
  char mybbs[MYBBSLEN+1];           // 40 A FORWARD
  char away;                        //  1 AWAY-Funktion aktiv (DH8YMB)
  char restplatz[81];               // 81 ist noch frei (definiert 0)
  long unsigned filepos;            //  4 Position im Userfile
  long unsigned nextsamehash;       //  4 hash list link
  short unsigned filepos_old;       //  2 (obsolete) Position im Userfile
  short unsigned nextsamehash_old;  //  2 (obsolete) hash list link
                                    //  = 512 Bytes
} userold_t;
#else
typedef struct userold_t
//*************************************************************************
//
//  Struktur fuer die alten Userdaten users3.bcm der WinNT/Linux-Version,
//  beruecksichtigt Alignment vom GCC (mind. 4 Byte)
//
//*************************************************************************
{ time_t   lastboxlogin;                //  4 letzter Login (UNIX)
  time_t   lastdirnews;                 //  4 letztes DIR NEWS / Check (UNIX)
  time_t   lastquit;                    //  4 letztes QUIT
  time_t   mybbstime;                   //  4 Datum des letzten MYBBS (UNIX)
  time_t   lastload;                    //  4 interner Merker fr Verwaltung
  long unsigned daybytes;               //  4 gelesene Bytes heute
  long     mailsent;                    //  4 gesendete Nachrichten
  long     mailgot;                     //  4 erhaltene Nachrichten
  long     mailread;                    //  4 gelesene Nachrichten
  long unsigned logins;                 //  4 logins
  bitfeld  opt[8];                      // 32 eingestellte Optionen
  long     spare_long[10];
  short unsigned helplevel;             //  2 A HELPLEVEL
  short unsigned zeilen;                //  2 A LINES
  short unsigned lf;                    //  2 A LF
  short unsigned status;                //  2 A STATUS (Bit-Field)
  short unsigned filepos_old;           //  2 (obsolete)Position im Userfile
  short unsigned nextsamehash_old;      //  2 (obsolete)hash list link
  short unsigned fdelay;                //  2 Verzoegerung fr eigene Nachrichten
  short unsigned fhold;                 //  2 Verzoegerung fr Nachrichten
  short unsigned paclen;                //  2 packet length
  short unsigned spare_short[19];
  char     call[CALLEN+1];              //  7 Rufzeichen des Users
  char     name[NAMELEN+1];             // 15 A NAME
  char     oldmybbs[OLDMYBBSLEN+1];     // 25 for compatibility with old mybbs field
  char     prompt[PROMPTLEN+1];         // 21 A PROMPT
  char     sprache[4];                  //  4 A SPEECH
  char     password[40];                // 40 A PW
  char     notvisible[LINELEN];         // 80 A REJECT
  char     firstcmd[FIRSTCMDLEN+1];     // 21 A COMMAND
  char     nopurge;                     //  1 Board wird nicht geputzt
  char     nameok;                      //  1 Name selbst eingegeben
  char     mybbsok;                     //  1 MYBBS selbst eingegeben (1)
  char     charset;                     //  1 A CHARSET (nicht impl)
  char     ttypw[9];                    //  9 A TTYPW (TTY-Password)
  char     uplink[CALLSSID+1];          // 10 uplink-Digi
  char     readlock;                    //  1 Privatmails "nicht lesbar"
  char     pwline;                      //  1 Leerzeile beim Login
  char     echo;                        //  1 Eigene Eingaben zurckschicken
  char     rlimit;
  char     ufwd[40];                    // 40 Connect-Path fuer User-forwarding
  char     loginpwtype;                 //  1 Password-type for ax-login (DH3MB)
  char     sfpwtype;                    //  1 Password-type for S&F (DH3MB)
  char     newcall[CALLEN+1];           //  7 New callsign (lizence update)
  char     dirformat;                   //  1 Dir/Check/List in new format
  char     unsecure_smtp;               //  1  0=>needs to pop before smtp
                                        //     1=>smtp without pop allowed
  char     binmode;                     //  1 AutoBIN/YAPP/DIDADIT bei BIN-Mails
  char     ttycharset;                  //  1 A TTYCHARSET (nicht impl)
  char     mybbs[MYBBSLEN+1];           // 40 A FORWARD
  char     away;                        //  1 AWAY-Funktion aktiv (DH8YMB)
  char     restplatz[2];                //  2 ist noch frei (definiert 0)
  unsigned long filepos;                //  4 position within file
  unsigned long nextsamehash;           //  4 hash to next record
                                        // = 512 Bytes (473)
} userold_t;
#endif
#endif

/*---------------------------------------------------------------------------*/

typedef struct wpdata_t
{
  char   call[CALLEN+1];
  char   bid[BIDLEN+1];
  char   bbs[HADRESSLEN+1];
  char   logincall[CALLEN+1];
  char   origin[CALLEN+1];
  char   name[NAMELEN+1];
  char   zip[ZIPLEN+1];
  char   qth[QTHLEN+1];
  char   hadr[HADRESSLEN+1];
  char   bstatus[BSTATUSLEN+1];
  char   sysopcall[CALLEN+1];
  char   protocol[BPROTOLEN+1];
  char   hwaddress[BHWADDRESSLEN+1];
  time_t mybbstime;
  short  hops;
  long   qual;
  long   bversion;
} wpdata_t;

/*---------------------------------------------------------------------------*/

#ifdef _WXSTN
// for wx-station
typedef struct
{ int data_valid;
  long
        dayoyear,
        minuteofday,
        wind_beaufort;
  double
        sat_sp,            /* saturation steam pressure */
        rainltt,           /* rain long term total  */
        steam_pressure,
        wind_chill,
        windspeed,
        outdoort,
        snowfall_limit,
        air_pres_qnh,
        air_pres_qfe,
        abs_humidity,
        dew_point,
        kond_niveau,
        indoort,           /* indoor temperature */
        humidity,
        hum_indoor,        /* humidity indoor */
        wind_direction;    /* 0..360 degrees */
        char *winddir_str;
        time_t t;
} wxdata_t;
#endif

/*---------------------------------------------------------------------------*/

typedef enum option_index_t
//*************************************************************************
//
//  Index fr das Feld mit den Optionen
//
//*************************************************************************
{ o_id=0,  // info-dir
  o_ud,    // user-dir
  o_il,    // info-list
  o_ul,    // user-list
  o_ir,    // info-read
  o_ur,    // user-read
  o_ch,    // check
  o_ps     // ps
} option_index_t;

/*---------------------------------------------------------------------------*/

typedef enum umlaut_t
{ um_none,      // keine Umlautwandlung
  um_ibm,       // IBM-Umlaute
  um_din,       // DIN-Umlaute (statt [\]{|}~)
  um_aeoeue,    // Wandlung nach AE OE UE
  um_iso        // Wandlung nach ISO (Linux,Windows)
} umlaut_t;

/*---------------------------------------------------------------------------*/

typedef enum fwdtype_t
{ fwd_none,
  fwd_standard,
  fwd_user,
  fwd_file
} fwdtype_t;

/*---------------------------------------------------------------------------*/

typedef enum loginmode_t
{ login_silent,
  login_standard,
  login_ufwd,
  login_fwd,
  login_nofwd
} loginmode_t;

/*---------------------------------------------------------------------------*/

typedef struct bulletin_t
{ char     name[MAXTREELENGTH];
  byte     flatoffset; //offset of name w/o path
  short unsigned lifetime_min;
  short unsigned lifetime_max;
  //time_t   created;
  time_t   newestmail;
} bulletin_t;

/*---------------------------------------------------------------------------*/

#ifdef _TTY // JJ
typedef struct ttypara_t
{ int      comirq;
  int      comadr;
  char     cmdatz[60];
  char     cmdata[60];
  char     cmdatd[60];
  char     ringindicator[60];
  char     connectindicator[60];
  char     dialprefix[60];
  char     dialsuffix[60];
  int      ringtimeout;
  int      dialtimeout;
  int      dialdelay;
  int      connectdelay;
  int      maxcontime;
  int      maxcons;
  int      debug;
  int      ttytimeout;
} ttypara_t;
#endif

/*---------------------------------------------------------------------------*/

typedef struct reject_t //DF3VI
{ char  action;                 // R, G, E, F, H, L, P, O
  char  sender[LINELEN+1];      // <
  char  destin[LINELEN+1];      // >
  char  bid[LINELEN+1];         // $
  char  at[LINELEN+1];          // @
  char  type;                   // .
} reject_t;

/*---------------------------------------------------------------------------*/

#define MK_MYCALLS   8

typedef struct mailpara_t
{ char     boxname[CALLEN+1];
  char     boxadress[HADRESSLEN+1];
  char     boxheader[45];
#ifdef __FLAT__
  int      tcp_port;
  int      ftp_port;
  int      http_port;
  int      smtp_port;
  int      pop3_port;
  int      nntp_port;
  int      serv_port;
  int      radio_port;
  unsigned nopopsmtp;
  unsigned httpaccount;
  unsigned httpguestfirst;
  unsigned httpttypw;
  unsigned unsecurettypw;
#endif
#if defined __LINUX__ && defined _AX25K
  char     ax25k_if[80];
#endif
#ifndef __LINUX__
  int      summertime;
#endif
#ifdef __DOS16__
  int      pcisutc;
  int      stimeoffset;
#endif
  unsigned short paclen;
  int minpaclen;
  int maxpaclen;
  unsigned altboardinfo;
  unsigned mailbeacon;
  unsigned timeoutwarning;
  unsigned nounknownroute;
  unsigned asklogin;
  unsigned smoothheader;
#ifdef __LINUX__
  unsigned addlinuxsystemuser;
#endif
  unsigned fwdssid;
  unsigned callformat; //format amateur/cb/both
#ifdef _LCF //JJ
  unsigned logincallformat;
#endif

  unsigned savebroken; // save broken 7+files:
           // 0..do not save, 1..save if fbb-fwding, 2..always save it
  char     sysopcall[CALLEN+1];
#ifdef _GUEST
  char     guestcall[CALLEN+1];
#endif
  unsigned infolife;
  unsigned userlife;
  unsigned oldestfwd;
  unsigned oldestbeacon;
  char     userpath[FNAMELEN+1];
  char     infopath[FNAMELEN+1];
#ifdef FILESURF // DH3MB
  char     fspath[FSPATHLEN+1];
#endif
  char     m_filter[FNAMELEN+1];
  char     prompt[PROMPTLEN+1];
  char     sprache[4];
  char     firstcmd[FIRSTCMDLEN+1];
  char     mycall[4][CALLSSID+1];
  char     macro_mycall[MK_MYCALLS][CALLSSID+1];
  unsigned mycalls;
  unsigned macro_mycalls;
  unsigned helplevel;
  unsigned zeilen;
  unsigned deflf;
  unsigned short defstatus;
  unsigned short defhold;
#ifdef FBBCHECKREAD
  unsigned deffbbcheckmode;
#endif
  unsigned tracelevel;
  unsigned fwdtrace;
  unsigned dosinput;
  unsigned autotrcwin;
  unsigned sysopbell;
  unsigned usvsense;
  unsigned watchdog;
  unsigned userquota;
  unsigned maxlogins;
  unsigned disable;
  unsigned sf_only;
  unsigned disable_user;        //no user-logins allowed
  unsigned scrolldelay;
  unsigned fwdtimeout;
  unsigned usrtimeout;
  unsigned holdtime;
  unsigned crtsave;
  unsigned timeslot;
  unsigned hadrstore;
  unsigned userpw;
  unsigned readlock;
  unsigned eraselog;
  unsigned remerase;
  unsigned createboard;         // 0: TMP wird erzeugt, keine Subboards
                                // 1: TMP wird erzeugt, Subboards
                                // 2: kein TMP, keine Subboards
  long     maxbids;             // max. nr of bids
  unsigned bidoffset;           // offset of bids (multiple bbs)
  bitfeld  opt[8];              // eg. fwd-options
  unsigned long maxusers;       // max. nr. of users
#ifdef _AUTOFWD
  unsigned autofwdtime; // hrx
#endif
  unsigned nopurge;
#ifdef MAILSERVER // DH3MB
  unsigned maillistserv;
  unsigned maillistsender;
#endif
#ifdef DF3VI_POCSAG
  unsigned pocsaglistserv;
#endif
  unsigned oldumail;
  unsigned defswaplf;
#ifdef _TTY
  unsigned ttydevice;
#endif
#ifdef _WXSTN
  wxdata_t wx;
  char wxstnname[31];
  /* absolute altitude of qth in meter */
  long wxqthaltitude;
  /* relative altitude of sensor over ground */
  long wxsensoraltitude;
  char wxtty[21];
  char wxpath[30];
#endif
#ifdef _MORSED
  char cwid[50];        //CW station ID  eg = QST DE OE1XUR =
  long cwdoid;          //1 should send ID now, 0 else
  char cwnextjob[50];   //defines next job to do eg. TXFILE morse.txt
  long cwfreq;          //frequ. of cw-signal in hz. eg. 800
  long cwms;            //duration of a "dot" in ms
#endif
  unsigned tellmode;    //0..inactive, 1..send ok, 2..send/receive ok
  unsigned ltquery;
#ifdef _BCMNET_LOGIN
  int pwonly;
#endif
  int defrea;
#if defined FEATURE_SERIAL || defined _TTY
  char     ttymode[20];         // z.B. 1:9600,8,N,1,E or /dev/tty7
#endif
#ifdef _PREPOSTEXEC //db1ras
  char dospreexec[CMDBUFLEN];
  char dospostexec[CMDBUFLEN];
#endif
} mailpara_t;

/*---------------------------------------------------------------------------*/

typedef struct conv_t
{ struct conv_t *next;
  char line[100];
} conv_t;

/*---------------------------------------------------------------------------*/

typedef struct tvar_t : public task_t
{ char     logincall[CALLEN+1]; // Rufzeichen der eingelogten Station
  char     uplink[CALLSSID+1];  // erstes Digirufzeichen bzw. 'Console'
  char     via_radio;           // 1 = connection via radio (for maxlogin)
  char     downlink[CALLSSID+1];// letztes Digirufzeichen
  char     peerip[18];          // IP-Nummer
  char     mycall[CALLSSID+1];  // Connect-Rufzeichen ZUR Box
  int      semalock;            // Flag: File war gesperrt
  char     bereich;             // Flag fr Bereich wurde angegeben
  bitfeld  optplus;             // gesetzte Optionen der Kommandozeile
  bitfeld  optminus;            // gelschte Optionen
  int      optgroup;            // Index fr Option (vom Befehl abhngig)
  bitfeld  opt;                 // modifizierte Option (abh. Bef/Opt/U/I)
  char     line[BUFLEN];        // Mehrzweckpuffer
  long     txbytes;             // Zhler fr gesendete Daten
  long     rxbytes;             // Zhler fr empfangene Daten
  unsigned sentfiles;           // Zhler fuer gesendete Files
  unsigned readfiles;           // Zhler fuer gelesene Files
  int      linecount;           // Zhler fuer Zeilenumbruch (Ausgabe)
  int      abbruch;             // Flag fr Ausgabe-Stop
  int      quit;                // Flag fr 1=logout 2=fast logout
  char     eingabefehler;       // counter for input-errors
  char     mailtype;            // type of mail: B(ulletin), P(ersonal), ...
  char     fwdhold;             // mail will not be forwarded automatically
                                // !..mail will be forwarded
                                // B..binary, partner does not support
                                // E..error, no bid (bulletin)
                                // F..deleted after forward, mail will not be forwarded again
                                // F..mail on hold if S&F without pwd (reject.bcm)
                                // H..general hold (reject.bcm)
                                // K..no BIN mails
                                // L..loop, fwd loop
                                // L..mail on hold if entered local (reject.bcm)
                                // M..no 7plus mails
                                // M..m_filter, no fwd (errorlevel 2)
                                // N..FBB_NO already rcvd, partner had mail before
                                // O..mail on hold if without ax25/tty-pwd (reject.bcm)
                                // P..mail on hold if without ax25-pwd (reject.bcm)
                                // R..FBB_REJECT
                                // S..size, mail too large
                                // X..set to hold by sysop
                                // Z..mail on hold if sent from a guest
  char     fwdprop;             // mail was proposed to the forward-partner
  char     replied;             // mail was replied
  char     msgty;               //msgtype
                                // !..unknown
                                // 6..7plus with errors
                                // 6..7plus encoded file
                                // 8..7plus info-file
                                // 9..7plus text-file
                                // H..html-encoded mail
  char     eraseinfo,           // duplicate to geloescht
                                // '!'.. not erased
                                //  F..forwarded
                                //  E..user-erase
                                //  S..sysop-erase
                                //  W..server(WP,mail,tell)-erase
                                //  K..local remote-erase
                                //  L..remote-erased (bbs=orig.bbs)
                                //  X..remote-erased (bbs differ)
                                //  T..erase due to transfer
           flag7,flag8,
           flag9,flaga,flagb,flagc,
           flagd,flage,flagf,flag0; // further flags, reserved for future use
                                    // set to ! (default)
#if 0
  char     chatbuffer[100];     // Zeile fuer Mitteilungen von anderen
#else
  conv_t  *conv;
  int      convtable;
#endif
  char     sysop;               // Flag: Benutzer hat Sysoprechte
  char     pwok;                // Benutzer hat Userrechte (PW wie DPBOX)
  FILE     *inputfile;          // Filepointer, wenn Eingabe umgeleitet ist
  FILE     *outputfile;         // Filepointer, wenn Ausgabe umgeleitet ist
  FILE     *oldfile;            // Merker fuer Filepointer
  char     oldoldinput;         // Merker fuer Standardeingabemerker
  char     oldinput;            // Merker fr Standardeingabe
  char     oldoutput;           // Merker fr Standardausgabe
  char     continous;           // Flag: Ausgabe wird nicht angehalten
  time_t   logintime;           // Merker, wann der Login war
  int      privoffset;          // index in PRIV-File (fr Forward-PWD)
#ifdef FEATURE_MDPW
  char     password[33];        // zuletzt aktives Passwort (fuer Fwd)
#else
  char     password[6];         // zuletzt aktives Password (fwd!)
#endif
  int      job;                 // Wird in User-Liste angezeigt

  char     prompt[30];          // Call/Boardname im Prompt
  char     mask[FNAMELEN+1];    // momentan aktive Dir-Maske (ende *.*)
  int      index;               // Index in Board-Tree (nur temporr)
  char     mailpath[FNAMELEN+1];// Name der aktiven Mail mit Pfad
  char     mailfname[10];       // nur Filename (=Datum/Uhrzeit) der Mail
  char     listpath[FNAMELEN+1];// Name des akiven Listfiles mit Pfad
  char     boardpath[FNAMELEN+1]; // Dateipfad fr Board (z.B. "info/soft/gp")
  char     boardname[10];       // Name des Boards ohne Pfad (z.B. "GP")
  char     boardfullname[FNAMELEN+1]; // Boardname komplett (z.B. "SOFT/GP")
  char     ziel[DIRLEN+1];      // evtl unvollst. Ziel nach SEND
  char     zielboard[DIRLEN+1]; // DH3MB: Board nach convname.bcm
  char     herkunft[CALLEN+1];  // Call des Verfassers der Mail
  char     frombox[CALLEN+1];   // Box, von der WIR die Mail bekommen haben
  char     at[HADRESSLEN+1];    // vollstndige H-Adresse der Nachricht
  char     bid[BIDLEN+1];       // BID der letzten Nachricht, evtl neu
  long     binstart;            // Position des BIN-Teils in der Mail-Datei
  char     destboxlist[DESTBOXLEN+1];   // Forward-Liste der Nachricht
  char     usermail;            // Nachricht ist User-Nachricht
  char     gelesen;             // Nachricht ist schon gelesen
  char     geloescht;           // Nachricht ist geloescht
  int      lifetime;            // Lifetime (insgesamt, nicht aktuell)
  unsigned lines;               // Anzahl Zeilen der letzten Nachricht
  long     bytes;               // Anzahl Bytes der letzten Nachricht
  char     betreff[BETREFFLEN+1]; // Titel der Nachricht
  time_t   abwann;              // Zeitangabe fr DIR AFTER etc.
  unsigned long beginn;         // Bereich fr DIR READ ERASE CHECK
  unsigned long ende;           // Bereich fr DIR READ ERASE CHECK
  char     replyboard[10];      // Boardname der zuletzt gelesenen Nachricht
  unsigned replynum;            // Nummer der zuletzt gelesenen Nachricht
  char     tmpbid[5][BIDLEN+1]; // Momentan empfangene BIDs
  int      boardlife_max;       // momentan aktive maximale Lifetime
  int      boardlife_min;       // momentan aktive minimale Lifetime
  int      msg_loadnum;         // "magic number" fuer geladene MSG-Version
  int      msg_offset;
  time_t   lastdirnews;         // exakter Zeitpunkt des D N (Check)
  fwdtype_t forwarding;         // fwd_none, fwd_standard, fwd_user
  void    *fwd_parameter;       // ggf. Zeiger auf fpara-struktur
  char     boxtyp;              // Software, die beim Partner rennt
  char     boxversion;          // Version der Forwardpartner-Box
  void    *script_p;
  char    *inbuffer;
  int      inbindex;
  int      inbmax;
  char    *outbuffer;
  int      outbindex;
  int      outbmax;
  int      http;
  int      ftp;
  unsigned charset;
  jmp_buf  io_mem_jmp;
  user_t   u;                   // USER-Struktur fuer eingeloggten User
#ifdef __FLAT__
  int      headermode;
#endif
#ifdef FILESURF // DH3MB
  char     fspath[100];
  char     fsmode;
#endif
  unsigned long fbboffset; // DH3MB
  char     pacbytes;            // like txbytes but one packet only
#ifdef _BCMNET_LOGIN
  char     logintype;           // hpk: Is the call a normal user or a guest?
                                //      0 ... guest / 1 ... normal
#endif
} tvar_t;

/*---------------------------------------------------------------------------*/

typedef struct fwdpara_t
{ char    call[CALLEN+1];       // Rufzeichen der Nachbarboxen
  char    concall[FSPATHLEN];   // Connect-Rufzeichen der Nachbarboxen
  char    times[25];            // Bytefeld fuer die Uhrzeiten
  long    maxbytes;             // maximale Anzahl pro geforwardetes File
  bitfeld options;              // eingestellte Optionen
  char    connectbar;           // war beim letzten Versuch erreichbar
  time_t  lastconok;
  time_t  lastlogin;
  time_t  lastwp;
  time_t  sidrtt;
  long    timeout_cnt;          // number of timeouts
  long    n_conok;              // number of outgoing connects
  long    n_login;              // number of incoming connects
  long    txf;                  // number of files sent
  long    rxf;                  // number of files received
  char    ssid;
  char    newmail;
  char    mid;
  char    u_onlydelay;
  char    i_onlydelay;
  int     fwdcallformat;        // callformat allowed for forwarding
} fwdpara_t;

/*---------------------------------------------------------------------------*/

typedef enum boxkind_t
{ b_baycom,
  b_dxl,
  b_thebox,
  b_fbb,
  b_rli,
  b_mbl,
  b_dp,
  b_wgt,
  b_unknown
} boxkind_t;

/*---------------------------------------------------------------------------*/

typedef enum mail_modify_t
{ w_erase,
  w_unerase,
  w_forward,
  w_transfer,
  w_setlifetime,
  w_reply,
  w_comment,
#ifdef DF3VI_EXTRACT
  w_extract, //extract-funktion
#endif
  w_unread,  //unread-funktion (Ruecksetzen des gelesen-flags)
  w_hold
} mail_modify_t;

/*---------------------------------------------------------------------------*/

typedef enum
{ unbekannt,
  bekannt,
  bleibtliegen,
  auto_bekannt
} fwd_weiter_t;

/*---------------------------------------------------------------------------*/

typedef enum
{ sh_noinput,
  sh_forceinput,
  sh_ifmultitask,
  sh_interactive
} shellinput_t;

/*---------------------------------------------------------------------------*/

typedef struct hadr_t
{
  long   bulletins;                  // 4
  long   usermails;                  // 4
  time_t delay[ADJNUM];              // 80
  time_t lastupdate[ADJNUM];         // 80
  time_t lasthtime;                  // 4 latest header-update scanned (mail)
  time_t lastwprcvd;                 // 4 latest wp-update received
  time_t lastwpsend;                 // 4 latest wp-update sent
  long   bversion;                   // 4
  time_t r_time_rx;                  // 4
  time_t r_time_tx;                  // 4
  time_t reserved_t[22];             // 88
  short  int rel_mails[ADJNUM];      // 40
  short  int hops[ADJNUM];           // 40
  short  unsigned nextsamehash;      // 2
  short  reserved_s[25];             // 50
  char   adr[HADRESSLEN+1];          // 40
  char   adjacent[ADJNUM][7];        // 140
  char   lastheader[HEADERLEN+1];    // 61
  char   lastbid[BIDLEN+1];          // 13
  char   lastboard[DIRLEN+1];        // 9
  char   lastuser[CALLEN+1];         // 7
  char   bstatus[BSTATUSLEN+1];      // 21
  char   sysopcall[CALLEN+1];        // 7
  char   protocol[BPROTOLEN+1];      // 11
  char   hwaddress[BHWADDRESSLEN+1]; // 50
  char   r_from[CALLEN+1];           // 7
  short  r_hops;                     // 2
  long unsigned r_qual_rx;           // 4
  char   reserved[240];              // 240
  } hadr_t;                          // = 1024 Bytes

/*---------------------------------------------------------------------------*/

#define ADJOLDNUM 5

#ifdef __MSDOS__
typedef struct hadrold_t
{ char   adr[HADRESSLEN+1];     // 40
  char   adjacent  [ADJOLDNUM][7];    // 35
  short  int rel_mails [ADJOLDNUM];   // 10
  time_t delay [ADJOLDNUM];        // 20
  time_t lastupdate[ADJOLDNUM]; // 20
  short  int hops      [ADJOLDNUM];   // 10
  long   bulletins;             // 4
  long   usermails;             // 4
  time_t lasthtime;             // 4
  char   lastheader[HEADERLEN+1];  // 61
  char   lastbid[BIDLEN+1];     // 13
  char   lastboard[9];       // 9
  char   lastuser[7];         // 7
  char   reserved[17];       // 51
  short unsigned nextsamehash;     // 2
} hadrold_t;
#else
typedef struct hadrold_t        // 290
{
  long   bulletins;             // 4
  long   usermails;             // 4
  time_t delay     [ADJOLDNUM]; // 20
  time_t lastupdate[ADJOLDNUM]; // 20
  time_t lasthtime;             // 4
  short  int rel_mails [ADJOLDNUM];   // 10
  short  int hops      [ADJOLDNUM];   // 10
  short  unsigned nextsamehash; // 2
  char   adr[HADRESSLEN+1];     // 40
  char   adjacent  [ADJOLDNUM][7];    // 35
  char   lastheader[HEADERLEN+1];  // 61
  char   lastbid[BIDLEN+1];     // 13
  char   lastboard[9];          // 9
  char   lastuser[7];           // 7
  char   reserved[17];          // 51
} hadrold_t;
#endif

/*---------------------------------------------------------------------------*/

//RX: A->B
//TX: B->A
typedef struct {
  char a;
  char b;
} charset_entry;

typedef struct {
  unsigned id;
  char* name;
  charset_entry* chars;
} charset;

/*---------------------------------------------------------------------------*/

extern charset** charsets;
extern unsigned treelen;
extern bulletin_t *tree;
extern unsigned fwdpartners;
extern unsigned fwddestlen;
extern unsigned fwddest;
extern mailpara_t m;
#ifdef _TTY //JJ
extern ttypara_t tty;
#endif
extern time_t einschaltzeit;
extern time_t initzeit;
extern tvar_t *b;
extern user_t *u;
extern int boxinaktiv;
extern int reorg_noetig;
extern char abortreason[];
extern int runterfahren;
extern char *stopreason;

//****************************
//      mbutil.cpp
//****************************
char            *makeheader(int full);
char            *dezasc(long dez,int stellen);
long            nonlin(long bytes);
long            inonlin(long bytes);
long            ascdez(char *s,int stellen);
char            deznib(int dez);
char            *time2filename(time_t unixtime);
time_t          filename2time(char *name);
int             mbcallok(char *call);
#ifdef _LCF
int             fwdcallok(char *call, int fwdcallformat); //JJ
#endif
char            mbmailt(char *ziel,char *hadr);
int             mbhadrok(char *hadr);
void            findbereich(char *buf);
time_t          seek_fname(handle fh,char *fname,char *ok);
int             seek_lastentry(handle fh,unsigned long anzahl);
void            scanoptions(char *buf);
void            formoptions(void);
char            *chartomakro(char c,char *ms);
char            *expandmakro(char *s,char *os);
int             filecopy(char *src,char *dest);
int             xmkdir(char *path);
void            leerzeile(void);
char            *getheaderadress(char *rline);
char            *getlt(char *rline);
char            *getbid(char *rline);

time_t          getheadertime(char *rline);
char            *atcall(char *at);
int             line_7p(char *p);
int             returnmailok(void);
time_t          yymmdd2ansi(char *yymmdd);
int             homeadr(char *adr);
int             autosysop(void); //JJ
void            rubrik_completition(char *); //dk2ui
unsigned int    hd_space (long flen);
char            interactive (void); //db1ras

//****************************
//      mbbids.cpp
//****************************
char            *bidvorhanden(char *bidname);
int             tmpbidvorhanden(char *bidname);
char            *bidnewfilename(char *bidname,char *newfilename);
void            tmpbidrein(char *bidname, int j);
void            tmpbidraus(int j);
unsigned        bidrein(char *bidname,char *filename);
void            bidinit(int begin);
void            listbids(char *sel);
char            *newbid(void);
long            bid_len(void);
void            reorgbid(void);

//****************************
//      mbdir.cpp
//****************************
int             finddir(char *path,int one_letter_boards);
handle          preparedir(char *selektor,int printerror);
void            mbdir(char *selektor,int listcmd);
char            *make_mask(char *mask,char *path);
time_t          dirline_data(char *dirline);
void            sendmailbake(char *name);
void            board_info(char *board);

//****************************
//      mbcheck.cpp
//****************************
void            makecheck(void);
void            mbcheck(char *selektor,time_t abwann);
void            make_checknum(char *from);
void            purgecheck(char *name);
unsigned long   mbcheckcount(void);
char            *checklinetoboard (unsigned long nummer);

//****************************
//      mbsend.cpp
//****************************
char            testmaildirectory (void);
int             mbsend(char *befbuf, int changedir);
void            savemail(void);
char            wantmail(char *reason);
char            searchreject(void);
#ifdef DF3VI_REJ_EDIT
void            rejectlistedit (char * befbuf);
#endif
int             parse_headerline(void);
int             mbsend_parse(char *befbuf,int def);
void            writeheader(FILE *sendf,int transfer);
void            writelines();
void            writemailflags();
void            generate_ack(char *to,char *from,char *subj);
void            add_unknown(char *zielboard);
void            save_em();
void            update_mail(void);
void            convat(char *adr);
#ifdef __FLAT__
int             smtp_convert(char*);
char            *create_bin_header(char *);
bool            mime2bin(FILE*, FILE*);
bool            quoted2bin(FILE*, FILE*, char*);
#endif
#ifdef _BCMNET_FWD
int             is_bcmnet_bid(char *bid, int cflag, char *call);
#endif
#ifdef _BCMNET_GW
int             is_bcmnet_user(char *call);
int             is_bcmnet_mybbs(char *call, char *bid, char *bbs, long btime,
                                char *origin, char *w_name, short hops);
#endif
void            set_boardlife_max (short int old_lt); //db1ras

//****************************
//      mbtrans.cpp
//****************************
int             mbtransfer(char *ziel);

//****************************
//      mbread.cpp
//****************************
int             mbread(char *befbuf,int mode);
int             mbchange(char *befbuf,int wasmachen,int kommentar);
int             rmemptydir(char *mask);
int             markerased(char reason,int unerase);
void            marklifetime(int tage);    //df3vi
void            sendbin(FILE *f, char *mailpath); //dg4iad: need actual filename for didadit-tx
time_t          get_mybbstime (char *call);

//****************************
//      mbtree.cpp
//****************************
void            mbreadtree(char *beginpath);
void            mbtreesave(void);
int             rmboard(char *fullname);
int             mkboard(char *mainboard,char *newboard,int sameboard);
int             mvboard(char *old,char *sub,char *newboard);
void            limit_list(void);

//****************************
//     convert.cpp
//****************************
void           mbcvtload(void);
int            convert (char *Name, int *convLT);
#ifdef DF3VI_CONV_EDIT
 void           convedit(char *befbuf);
 void           saveconvnames(void);
#endif

//****************************
//      mbinit.cpp
//****************************
void            mbinit(void);
int             mbinitbef(char *befbuf,int inifile);
int             mbinitdisp(char *befbuf);
void            mbparsave(void);

//****************************
//      mbusers.cpp
//****************************
void            listuser(char *wildcard,int lokal);
int             loaduser(char *usercall,user_t *u,int anlegen);
void            saveuser(user_t *u);
void            userinit(void);
void            defaultuser(char *usercall,user_t *u);
void            reorguser(int delempty);
void            uimport(void);
void            usersuch(char *befbuf);
void            hashinit(handle uhf,long hashsize);
void            us_deletecache(void);

//****************************
//      mbfwd.cpp
//****************************
int             isforwardpartner(char *);
char            another_fwd_sender(char *);
fwdpara_t       *fpara(void);
void            fwdlog(char *, char *, char);
void            fwdput(char *, char *);
void            fwdget(char *, int);
int             chkforward(char *);
void            initfwdlist(void);
void            dirfwdlist(char * dest);
void            printfwdlist(char *);
#ifdef DF3VI_FWD_EDIT
void            savefwdlist(char *);
void            fwdlistedit(char *befbuf);
#endif
void            fwdstat(char *);
int             isforwardtime(char *, int);
int             boxbinok(int);
void            add_hold(char *, int);
int             scanheader(FILE *, fwdpara_t *);
char*           board_aus_path(char *);
void            markfwd(void);
void            readmail(FILE *, char);
int             setfullpath(char *);
void            killforwarded(char *);
char            getfwdlistentry(char *, char, char, char **);
void            delfwdlistentry(char *);
void            fwdsend(char *);
int             fwdmainloop(void);
//int           weiterleiten2(int, char *);
int             weiterleiten(int, char *);
void            checkdouble_fwdfile(char *);
void            add_fwdfile(char *, short unsigned);
void            trigger_ufwd(char *);
void            startfwd(char *);
int             waitfwdprompt(char *);

//****************************
//      mbfwdfil.cpp
//****************************
#ifdef _FILEFWD
int             fwd_import(char *);
int             fwd_export(char *);
#endif

//****************************
//      mbfwdrli.cpp
//****************************
int             scan_userfile(char *, int);
void            fwdproc_reply(char);
void            ascii_fwdmachine(int);

//****************************
//      mbwp.cpp
//****************************
void            add_emfile (char *zeile, char *frombox, char *file_flag, char *boardname, char *at);
int             get_wcs (char *line);
void            addwp_m (wpdata_t  *wp);
void            addwp_e (char *at, char *originbbs, char *bid, char *bid_erase,
                        char *erase_user, short hops, char *reason, char *logincall);
void            wpgenheader (FILE *f);
void            gen_wpmail (char *call);
int             wpparse_fbb (char *buf, wpdata_t *wp);
int             wpparse_v (char *buf,long &protnum);
int             wpparse_b (char *buf, char *hadr, long &bversion, char *bstatus, char *sysop,
                        char *protocol, char *hwaddress, time_t &timestamp, short &hops);
int             wpparse_m (char *buf, wpdata_t *wp);
int             wpparse_e (char *buf, char *at, char* bid, char *originbbs,
                        char *bid_erase, char *origin, short &hops, char *comment);
int             wpparse_r (char *buf, wpdata_t *wp);
void            scan_wp (void);
void            remeraser (char *at, char *bid, char *herkunft, char *bid_erase,
                        char *logincall, char *erase_user, short hops, char *reason);

//****************************
//      mblogin.cpp
//****************************
void            mblogin(char *logincall,loginmode_t lmode,char *uplink);
void            mblogout(int discon_);
void            putlogauszug(char *selektor);
void            putaktuell(int immer);
int             readtext(char *text);

//****************************
//      mbreorg.cpp
//****************************
void            mbreorg(char *name);
void            createdirlist(int remdouble);
unsigned int    appenddirlist(void);
char            *dirsort(char *mask,int users);
void            postfwd(char *);

//****************************
//      mbalter.cpp
//****************************
int             get_mybbs(char *call,char *bbs,int setmybbs);
void            set_mybbs(char *call,char *bbs,long bime,char *bid,
                             char *origin, short hops,char *w_name);
void            set_name(char *call,char *name);
void            set_qth(char *call,char *qth);
void            set_zip(char *call,char *zip);
char            *get_name(char *call,int par);
char            *get_ttypw(char *call,char *pw);
#ifdef __FLAT__
int             put_ttypw(char *call,char *pw);
int             get_smtp_security(char *call);
char            *get_httppw(char *call, char *pw);
char            *get_pw(char *call, char *pw);
#endif
void            inc_mailgot(char *call);
void            inc_mailsent(char *call);
int             mbalter(char *bef,char *selektor,char *call);
char            *optstr(bitfeld option);
int             get_nopurge(char *call);
int             get_fdelay(char *call);
int             get_readlock(char *call);
char            *get_ufwd(char *call);
void            display_parameter(char *call,int full);
int             get_newcall(char *call,char *newcall);
int             get_usr_local(char *call, time_t &lastlogin);

//****************************
//      mbsysop.cpp
//****************************
int             sysbef(char *befbuf);
void            sysimport(char *befbuf);
void            testdfull(void);
void            putlog(char *name,char *befbuf);

//****************************
//      mbgrep.cpp
//****************************
int             grep(char *name,char *pattern,bitfeld options);

//****************************
//      mbmain.cpp
//****************************
int             mailbef(char *befbuf,int echo);
void            emptytempdir(void);
void            mbmainbegin(void);
void            mbmain(char *call,char *uplink,char *mycall);
int             checkquota(void);
void            mbmainloop(int doprompt);
int             test_job(job_typ);
#ifdef _WXSTN
 void           wxdaemon(char *name);
#endif

//****************************
//      mbinout.cpp
//****************************
char            getline(char *s,int maxlen,char cut);
int             janein(char *prompt);
void            putv(int c);
void            bputv(int c);
void            putf(char *format, ...);
int             getv(void);
int             bgetv(void);
int             getvalid(void);
int             putfree(void);
void            putflush(void);
int             testabbruch(void);
#ifdef _TTY
void            mon(int c,bitfeld opt);
#endif

//****************************
//      mbinterf.cpp
//****************************
#ifdef __DOS16__
void            mbwin2(char *name);
void            userwin(char *name);
void            taskwin(char *name);
void            doodle(int soundnum);
void            trcwin(char *befbuf);
#else
#define         doodle(x)
#endif
void            mbwindow(char *name);
void            boxusertask(char *usercall);
int             getlogin(char *s,int withpw,char *source);
void            mbimport(char *filename);
void            genmail(char *sendline,char *content);
void            runbatch(char *batch);

//****************************
//      mbrun.cpp
//****************************
#ifdef RUNUTILS
void            read_runfile(void);
int             start_runutil(char *befbuf);
void            list_runutils(char *befbuf);
#endif

//****************************
//      mbhelp.cpp
//****************************
void            mbinithelp(void);
void            mbreadhelp(char *befehl);

//****************************
//      mbpurge.cpp
//****************************
void            mbpurge(char *procname);
void            userpurge(char *befbuf);

//****************************
//      cfgflex.cpp
//****************************
void            cfgflex(char *zielcall);

//****************************
//      mbtnc.cpp
//****************************
#ifdef __DOS16__
void            monwindow(char *name);
#endif
#ifndef _AX25K_ONLY
void            set_paclen_tnc (unsigned short paclen);
void            putv_tnc(int c);
int             putfree_tnc(void);
void            putflush_tnc(void);
int             getv_tnc(void);
int             getvalid_tnc(void);
void            getclear_tnc(void);
void            inputline_tnc(char *s,int maxlen,char cut);
void            getmycall_tnc(char *outcall);
int             makeconnect(char *mycall,char *conncall);
void            mbdisconnect(int wait);
int             freeblocks_tnc(void);
#ifdef _TNC
 void           control_tnc(char *befehl);
#endif
void            putversion_tnc(void);
void            logindaemon(char *name);
void            setsession(void);
void            putbeacon_tnc(char *adressfeld, char *bakentext);
void            align_mycalls(void);
#else  // _AX25K_ONLY
void            setsession(void);
int             makeconnect(char *mycall,char *conncall);
void            logindaemon(char *name);

  #define putv_tnc(c)           ax25k_putv(c)
  #define putfree_tnc()         ax25k_putfree()
  #define putflush_tnc()        ax25k_flush()
  #define getv_tnc()            ax25k_getv()
  #define getvalid_tnc()        ax25k_getvalid_tnc()
  #define getclear_tnc()        ax25k_getclear()
  #define inputline_tnc(s,maxlen,cut)  ax25k_inputline(s,maxlen,cut)
  #define getmycall_tnc(s)      ax25k_getmycall(s)
  #define mbdisconnect(wait)    ax25k_disconnect(wait)
  #define freeblocks_tnc()      255
#ifdef _TNC
  #define control_tnc(bef)
#endif
  #define putversion_tnc()      extern int l2vorhanden; \
                                (l2vorhanden?putf("Linux Kernel AX25\n"):putf("-\n"))
  #define putbeacon_tnc(addr,text)     ax25k_putbeacon(addr,text)
  #define align_mycalls()
  #define call_l2(x)
#endif

#ifdef __FLAT__
//****************************
//      mbsocket.cpp
//****************************
void            putv_sock(int c);
int             putfree_sock(void);
void            putflush_sock(void);
int             getv_sock(void);
int             getv_sock_ftp(void);
int             getvalid_sock(void);
void            inputline_sock(char *s,int maxlen,char cut);
void            logindaemon_sock(char *name);
void            disconnect_sock(void);
void            show_sock(void);
int             myhostname (char *s, int len);
char*           get_fqdn();
#ifdef _TELNETFWD
int             telnet_fwd_connect(char* addr);
#endif
int             ftp_connect (char* , unsigned int);


enum
{
  _TELNET=-1, _HTTP=-2, _SMTP=-3, _POP=-4, _NNTP=-5, _SERV=-6, _RADIO=-7, _FTP=-8
};

//****************************
//      mbhttp.cpp
//****************************
void            mblogin_http(char *);
void            html_putf(char *format, ...);
int             isamprnet(char *ip);

//****************************
//      mbsmtp.cpp
//****************************
void            rfc2047_decode (char *, const char *, size_t);
void            mblogin_smtp(char *);
char*           extract_call (char *line, int from);


//****************************
//      mbpop3.cpp
//****************************
void            mblogin_pop3(char *name);
void            show_popdb(void);

//****************************
//      mbnntp.cpp
//****************************
#ifdef NNTP
void            mblogin_nntp(char *name);
#endif
//****************************
//      mbserv.cpp
//****************************
void            mblogin_serv(char *name);

//****************************
//      mbradio.cpp
//****************************
void            mblogin_radio(char *name);

//****************************
//      mbftp.cpp
//****************************
void            mblogin_ftp(char *);

#endif //__FLAT__


//****************************
//      mbflex.cpp
//****************************
#ifdef __MSDOS__
void            f_putv_tnc(int c);
int             f_putfree_tnc(void);
void            f_putflush_tnc(void);
int             f_getv_tnc(void);
int             f_getvalid_tnc(void);
void            f_getclear_tnc(void);
void            f_getmycall_tnc(char *outcall);
void            f_inputline_tnc(char *s,int maxlen,char cut);
int             f_makeconnect(char *mycall,char *conncall);
void            f_mbdisconnect(int wait);
int             f_freeblocks_tnc(void);
void            f_control_tnc(char *befehl);
void            f_putversion_tnc(void);
void            f_logindaemon(char *name);
void            f_monwindow(char *name);
void            f_setsession(void);
void            f_putbeacon_tnc(char *adressfeld, char *bakentext);
void            disable_tnc(void);
void            f_ax25_set_pid(unsigned short int qsonum, char pid);
#endif
//****************************
//      mbserial.cpp
//****************************
#ifdef FEATURE_SERIAL
void            putv_tty(int ch);
void            putflush_tty(void);
int             putfree_tty(void);
int             getv_tty(void);
int             getvalid_tty(void);
void            inputline_tty(char *s,int maxlen,char cut);
void            init_tty(void);
void            ttysetecho(int echo);
#endif
#ifdef _TTY // JJ
void            putv_tty(int ch);
void            putflush_tty(void);
int             putfree_tty(void);
int             getv_tty(void);
int             getvalid_tty(void);
void            inputline_tty(char *s,int maxlen,char cut);
void            init_tty(void);
void            ttysetecho(int echo);
void            putf_tty(char *format, ...);
int             tty_cmd(char *cmd);
int             tty_waitring(void);
int             tty_hangup(void);
void            tty_kill(void);
int             tty_dial(char *befbuf,int fwdtaskid);
int             tty_autologin(char *s);
void            tty_statustext(void);
void            tty_win(char *befbuf);
void            ttyinit(void);
int             ttyinitbef(char *befbuf,int inifile);
int             ttybef(char *befbuf);
void            ttyparsave(void);
void            tty_counterreset(void);
#endif

//****************************
//      mbmsg.cpp
//****************************
char            *ms(MSG_TYP msgnum);
char            *msg_landsuch(char *call);
void            msg_listspeech(void);
void            msg_dealloc(int all);
int             is_msgkenner(char *kenn);
unsigned        msg_limit(int actual);

//****************************
//      mbtimer.cpp
//      ad_timer.cpp
//****************************
void            set_watchdog(int on);
void            ad_settimer(int on,void (*callback)(void));
void            put_cpuload(void);
int             cpuload(void);
extern int      lastjob;

//****************************
//      mbhadr.cpp
//****************************
void            show_hadr(char *call);
int             update_hadr(char *headerline,int hops,int uplink);
void            reorg_hadr(void);
void            browse_hadr(char *search);
void            showpath(char *adr,int alles);
void            expand_hadr(char *adr,int force);
void            edit_hadr(bitfeld opt,char *line);
long            hadr_len(int max);
int             wpupdate_hadr(wpdata_t *wp);
void            hadrfile_newformat(void);
time_t          find_hadr(char *call);
int             rupdate_hadr (wpdata_t *wp);
//void          uclose(void);
//void          hadr_tryopen(void);
//int           loadhadr(char *hadrcall,hadr_t *u,int anlegen);

//****************************
//      mbterm.cpp
//****************************
void            termqso(char *calls);

//****************************
//      mbconv.cpp
//****************************
int             conversout(int prompt);
void            convers(char *befbuf,char *befname);

//****************************
//      ad_dos.cpp
//      ad_linux.cpp
//      ad_util.cpp
//****************************
int             oshell(char *befbuf,shellinput_t input);
char            *memfree(int swapfree);
char            *cpuinfo(void);
unsigned long   dfree(char *path,int total);
void            fixpath(char *argv0);
void            cdhome(void);
void            resetreadonly(char *name);
struct tm       *ad_comtime(time_t time);
time_t          ad_mktime(struct tm *tt);
time_t          loctime(void);
time_t          ad_time(void);
time_t          ad_timezone(void);
#ifdef BIOS_Y2K
void            chk_y2k_comp();
#endif
#ifndef _GNU_SOURCE
int             snprintf(char *str,size_t n,const char *format,...);
#endif
void            testcputask(void);
void            desktop(char *);

//****************************
//      mbcron.cpp
//****************************
void            mbcron(char *);
#ifdef __MSDOS__
//****************************
//      mbvideo.cpp
//****************************
void            video_open(void);
void            video_close(void);
void            video_putchar(int x,int y,int attr,int c);
void            video_setcursor(unsigned x,unsigned y);
void            video_putc(int x,int y,unsigned attr,unsigned c);
void            video_puts(int x,int y,unsigned attr,char *s);
void            video_update(void);
void            video_checkoff(int force);
void            video_switchon(void);
extern          int cgadisp;
extern          int monodisp;
extern          int novideo;
#endif
extern          int video_off;

//****************************
//      mbmacro.cpp
//****************************
typedef enum mk_job_t
{ MK_NOJOB,
  MK_LOGIN,
  MK_ACCEPT,
  MK_CMD,
  MK_SCMD,
  MK_BEFORECMD,
  MK_AFTERCMD,
  MK_MAILFROM,
  MK_MAILTO,
  MK_UNKNOWN
} mk_job_t;
#ifdef MACRO
int     mk_start(char *name);
void    mk_read_jobs(void);
int     mk_perform(mk_job_t job,char *parameter);
#else
 #define        mk_start(x) 0
 #define        mk_read_jobs()
 #define        mk_perform(x,y) 0
#endif

//****************************
//      mbax25k.cpp
//****************************
int     ax25k_putfree();
void    ax25k_putv(int c);
void    ax25k_flush();
void    ax25k_putbeacon(char *addr, char *beacontext);
int     ax25k_isdefault();
int     ax25k_init();
int     ax25k_reinit();
int     ax25k_getvalid_tnc();
int     ax25k_getv();
void    ax25k_getclear();
void    ax25k_getmycall(char *s);
void    ax25k_inputline(char *s, int maxlen, char cut);
int     ax25k_connect(char *mycall, char *conncall);
void    ax25k_disconnect(int wait);
void    ax25k_checklogin();
void    ax25k_shutdown();

//****************************
//      mbpw.cpp
//****************************
void    genPWstring(char *pw, char * pwstring, char * result);
char    maxpwtype();
char    *pwtypestr(char pwnum);
char    pwtypenum(char *pwstr);
int     getpw(void);
int     pwauswert(char *pw);
int     getpriv(char *befbuf,char *privname);

//****************************
//      mbmdpw.cpp
//****************************
#ifdef FEATURE_MDPW
void    calcMD2pw(char *MDstring, char *pw, char *MD2result);
void    calcMD5pw(char *MDstring, char *pw, char *MD5result);
void    genMDstring(char MDtype, char *pw, char *pwstring, char *result);
char    getMDpw(char MDtype, char *pw);
void    getMDsysoppw(char MDtype);
#endif

#ifdef _AUTOFWD
//****************************
//      mbafwd.cpp
//****************************
int     autofwd(char *call,int ausgabe);
void    initafwdlist();
void    afwdlist(char*);
#endif

#ifdef _MORSED
//****************************
//      mbmorse.cpp
//****************************
void    morsedaemon(char *tname);
void    morse_char(char x);
void    morse_word(char *text);
void    morse_line(char *line);
#endif

//****************************
//      charset.cpp
//****************************
void    init_charsets();

//****************************
//      mbserver.cpp
//****************************
void    send_tell(char *befbuf);
void    tellresp (char *name);
void    send_ping(char *befbuf);
void    pingresp (char *name);

//****************************
//      mbxtrct.cpp
//****************************
#ifdef DF3VI_EXTRACT
void    extract(unsigned pos);
#endif
//****************************
//      end of file
//****************************
